AUI.Minimap = {}

local isLoaded = false
local MINIMAP_SCENE_FRAGMENT = nil

function AUI.Minimap.IsLoaded()
	if isLoaded then
		return true
	end
	
	return false
end

function AUI.Minimap.GetVersion()
	return AUI_MINIMAP_VERSION
end

function AUI.Minimap.Show()
	MINIMAP_SCENE_FRAGMENT.hiddenReasons:SetHiddenForReason("ShouldntShow", false)
	AUI_Minimap_MainWindow:SetHidden(false)

	AUI.Minimap.Map.Refresh()
	AUI.Minimap.Pin.RefreshPins()	
end

function AUI.Minimap.Hide()
	MINIMAP_SCENE_FRAGMENT.hiddenReasons:SetHiddenForReason("ShouldntShow", true)
	AUI_Minimap_MainWindow:SetHidden(true)
	AUI.Minimap.Pin.RemoveCustomPinsByType()
end

function AUI.Minimap.IsShow()
	return not AUI_Minimap_MainWindow:IsHidden()
end

function AUI.Minimap.Toggle()
	if not isLoaded then
		return
	end

	if AUI.Minimap.IsShow() then
		AUI.Settings.Minimap.enable = false	
		AUI.Minimap.Hide()
	elseif not ZO_WorldMap_IsWorldMapShowing() then
		AUI.Settings.Minimap.enable = true	
		AUI.Minimap.Show()
	end
end

function AUI.Minimap.Load()
	if isLoaded then
		return
	end

	isLoaded = true
	
	-- For the default Theme		
	local defaultThemeData = {["Default_Frame"] = true}		
	AUI.Minimap.Theme.AddMinimapTheme("default", AUI.L10n.GetString("default"), defaultThemeData)		
	
	-- Add the default icon theme
	AUI.Minimap.Theme.AddMinimapIconTheme("default", AUI.L10n.GetString("default"), {})	
	
	-- For the Blank Theme		
	local blankThemeData = {["Default_Frame"] = false}		
	AUI.Minimap.Theme.AddMinimapTheme("blank", "Blank", blankThemeData)		
	
	AUI.Minimap.SetMenuData()		

	AUI.Minimap.Pin.Init()
	AUI.Minimap.UI.Init()	
	AUI.Minimap.Map.Init()	
	AUI.WorldMap.Init()	
	
	MINIMAP_SCENE_FRAGMENT = ZO_SimpleSceneFragment:New(AUI_Minimap_MainWindow)	
	MINIMAP_SCENE_FRAGMENT.hiddenReasons = ZO_HiddenReasons:New()		
    MINIMAP_SCENE_FRAGMENT:SetConditional(function()
        return not MINIMAP_SCENE_FRAGMENT.hiddenReasons:IsHidden()
    end)									
		
	MINIMAP_SCENE_FRAGMENT:RegisterCallback("StateChange", 
	function(oldState, newState)	
		if newState == SCENE_SHOWN then
			if not AUI.Settings.Minimap.enable then
				AUI.Minimap.Hide()		
			end
		end
	end)
		
	HUD_SCENE:AddFragment(MINIMAP_SCENE_FRAGMENT)
	HUD_UI_SCENE:AddFragment(MINIMAP_SCENE_FRAGMENT)
	SIEGE_BAR_SCENE:AddFragment(MINIMAP_SCENE_FRAGMENT)
	if SIEGE_BAR_UI_SCENE then
		SIEGE_BAR_UI_SCENE:AddFragment(MINIMAP_SCENE_FRAGMENT)
	end
end